/***************************************************************************
 *   Copyright (C) 2004 by Nicolas Brodu                                   *
 *   nicolas.brodu@free.fr                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "EventQueueViewer.h"

EventQueueViewer::EventQueueViewer()
: osgProducer::Viewer()
{
    // Nothing to do
}

EventQueueViewer::EventQueueViewer( Producer::CameraConfig * cfg )
: osgProducer::Viewer(cfg)
{
    // Nothing to do
}

EventQueueViewer::EventQueueViewer( const std::string & configFile )
: osgProducer::Viewer(configFile)
{
    // Nothing to do
}

EventQueueViewer::EventQueueViewer( osg::ArgumentParser & arguments )
: osgProducer::Viewer(arguments)
{
    // Nothing to do
}

EventQueueViewer::~EventQueueViewer()
{
    // Nothing to do
}

EventQueueViewer::GenericDispatcher::GenericDispatcher( )
{
    // Nothing to do
}

void EventQueueViewer::GenericDispatcher::dispatch( ) const
{
    // Nothing to do
}

EventQueueViewer::GenericDispatcher::~GenericDispatcher( )
{
    // Nothing to do
}

void EventQueueViewer::post( const GenericDispatcher * dispatcher )
{
    eventsAccessMutex.lock();
    events.push_back(dispatcher);
    eventsAccessMutex.unlock();
}

void EventQueueViewer::update( )
{
    // Swap vectors in a fast way so as not to block threads too long.
    std::vector<const GenericDispatcher*> currentEvents;
    eventsAccessMutex.lock();
    currentEvents.swap(events);
    eventsAccessMutex.unlock();

    // dispatch queued events.
    for (std::vector<const GenericDispatcher*>::iterator it = currentEvents.begin(); it!=currentEvents.end(); ++it) {
        (*it)->dispatch(); // execute code
        delete *it;     // destroy wrapper
    }

    // Call parent code in protecetd section
    //lock();
    Viewer::update();
    //unlock();
}

/*void EventQueueViewer::frame( )
{
    lock();
    Viewer::frame();
    unlock();
}
*/

