/***************************************************************************
 *   Copyright (C) 2004 by Nicolas Brodu                                   *
 *   nicolas.brodu@free.fr                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TERRAININTERFACE_H
#define TERRAININTERFACE_H

#include <osg/Vec3d>

/** For our purpose, a terrain is defined by it's height and normal at any point.

@author Nicolas Brodu
*/
struct TerrainInterface {

    /**
       Returns the Z coordinate of the floor at the given (x,y) world coordinate.
    */
    virtual double getFloorZ(const double x, const double y) = 0;
    
    /**
       Returns the normal of the floor at the given (x,y) world coordinate.
    */
    virtual osg::Vec3d getFloorNormal(const double x, const double y) = 0;
    
    /// C++ artifact
    virtual ~TerrainInterface() {};
};

#endif
