/***************************************************************************
 *   Copyright (C) 2004 by Nicolas Brodu                                   *
 *   nicolas.brodu@free.fr                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TRANSLATETRANSFORM_H
#define TRANSLATETRANSFORM_H

#include <osg/MatrixTransform>

/**
    This works exactly like a MatrixTransform for a translation,
    but is much faster to allocate: no temporary object needed,
    and no matrix inverse computation.

    @author Nicolas Brodu
*/
struct TranslateTransform : public osg::MatrixTransform {
    
    TranslateTransform(const double& x, const double &y, const double& z);
    
    TranslateTransform(const osg::Vec3d& trans);    
};


#endif
